/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         cifparse
#define yylex           ciflex
#define yyerror         ciferror
#define yylval          ciflval
#define yychar          cifchar
#define yydebug         cifdebug
#define yynerrs         cifnerrs
#define yylloc          ciflloc

/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 30 "cif_yacc.yy"

#include "tpdph.h"
#include <sstream>
#include "outbox.h"
#include "ttt.h"
#include "cif_io.h"
/* Switch on verbose error reporting messages*/
#define YYERROR_VERBOSE 1
extern CIFin::CifFile* CIFInFile;

void ciferror(std::string, TpdYYLtype);
void cifwarning(std::string, TpdYYLtype);
bool checkPositive(long, TpdYYLtype);



/* Line 268 of yacc.c  */
#line 96 "cif_yacc.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tknERROR = 258,
     tknPsem = 259,
     tknPdigit = 260,
     tknPremB = 261,
     tknPremE = 262,
     tknCend = 263,
     tknCdefine = 264,
     tknCpolygon = 265,
     tknCbox = 266,
     tknCround = 267,
     tknCwire = 268,
     tknClayer = 269,
     tknCcall = 270,
     tknCstart = 271,
     tknCfinish = 272,
     tknTint = 273,
     tknTshortname = 274,
     tknTuserText = 275,
     tknTuserid = 276,
     tknTupchar = 277,
     tknTblank = 278,
     tknTremtext = 279,
     tknCtranslate = 280,
     tknCmirror = 281,
     tknCmirx = 282,
     tknCmiry = 283,
     tknCrotate = 284,
     tknP9 = 285,
     tknP4A = 286,
     tknP4N = 287,
     tknP94 = 288
   };
#endif
/* Tokens.  */
#define tknERROR 258
#define tknPsem 259
#define tknPdigit 260
#define tknPremB 261
#define tknPremE 262
#define tknCend 263
#define tknCdefine 264
#define tknCpolygon 265
#define tknCbox 266
#define tknCround 267
#define tknCwire 268
#define tknClayer 269
#define tknCcall 270
#define tknCstart 271
#define tknCfinish 272
#define tknTint 273
#define tknTshortname 274
#define tknTuserText 275
#define tknTuserid 276
#define tknTupchar 277
#define tknTblank 278
#define tknTremtext 279
#define tknCtranslate 280
#define tknCmirror 281
#define tknCmirx 282
#define tknCmiry 283
#define tknCrotate 284
#define tknP9 285
#define tknP4A 286
#define tknP4N 287
#define tknP94 288




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 48 "cif_yacc.yy"

   unsigned       word;
   long           integer;
   char*          identifier;
   TP*            point;
   PointVector*     path;
   CTM*           ctmp;



/* Line 293 of yacc.c  */
#line 209 "cif_yacc.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 234 "cif_yacc.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   215

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  34
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  30
/* YYNRULES -- Number of rules.  */
#define YYNRULES  62
/* YYNRULES -- Number of states.  */
#define YYNSTATES  135

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     6,    10,    12,    14,    18,    22,    24,
      26,    28,    31,    35,    37,    39,    41,    43,    45,    47,
      49,    51,    53,    55,    57,    59,    64,    70,    80,    85,
      90,    95,    99,   107,   117,   122,   128,   134,   137,   140,
     145,   150,   155,   162,   169,   174,   175,   177,   181,   187,
     191,   195,   199,   203,   207,   208,   212,   214,   218,   219,
     221,   223,   225
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      35,     0,    -1,     8,    61,    -1,    36,     8,    61,    -1,
       3,    -1,     1,    -1,    61,    37,    63,    -1,    36,    37,
      63,    -1,    39,    -1,    42,    -1,    40,    -1,    39,    63,
      -1,    38,    39,    63,    -1,    45,    -1,    46,    -1,    47,
      -1,    48,    -1,    44,    -1,    49,    -1,    50,    -1,    51,
      -1,    52,    -1,    53,    -1,    54,    -1,    56,    -1,    41,
      63,    38,    43,    -1,     9,    61,    16,    61,    18,    -1,
       9,    61,    16,    61,    18,    62,    18,    62,    18,    -1,
       9,    61,     9,    18,    -1,     9,    61,    17,    61,    -1,
      14,    61,    19,    61,    -1,    10,    61,    60,    -1,    11,
      61,    18,    62,    18,    62,    57,    -1,    11,    61,    18,
      62,    18,    62,    57,    62,    57,    -1,    12,    18,    62,
      57,    -1,    13,    61,    18,    62,    60,    -1,    15,    61,
      18,    59,    61,    -1,     5,    20,    -1,    30,    21,    -1,
      31,    57,    23,    57,    -1,    33,    21,    23,    57,    -1,
      33,    18,    23,    57,    -1,    33,    21,    23,    57,    23,
      21,    -1,    33,    18,    23,    57,    23,    21,    -1,    32,
      21,    23,    57,    -1,    -1,    24,    -1,     6,    55,     7,
      -1,     6,    55,    56,    55,     7,    -1,    18,    62,    18,
      -1,    25,    61,    57,    -1,    26,    61,    27,    -1,    26,
      61,    28,    -1,    29,    61,    57,    -1,    -1,    59,    61,
      58,    -1,    57,    -1,    60,    62,    57,    -1,    -1,    23,
      -1,    22,    -1,    23,    -1,     4,    61,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    75,    75,    76,    77,    78,    82,    83,    87,    88,
      89,    93,    94,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   113,   117,   121,   132,   136,
     142,   149,   155,   164,   176,   180,   187,   194,   203,   210,
     218,   222,   230,   235,   244,   251,   252,   256,   257,   261,
     267,   270,   273,   276,   282,   285,   293,   298,   305,   306,
     310,   311,   315
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tknERROR", "tknPsem", "tknPdigit",
  "tknPremB", "tknPremE", "tknCend", "tknCdefine", "tknCpolygon",
  "tknCbox", "tknCround", "tknCwire", "tknClayer", "tknCcall", "tknCstart",
  "tknCfinish", "tknTint", "tknTshortname", "tknTuserText", "tknTuserid",
  "tknTupchar", "tknTblank", "tknTremtext", "tknCtranslate", "tknCmirror",
  "tknCmirx", "tknCmiry", "tknCrotate", "tknP9", "tknP4A", "tknP4N",
  "tknP94", "$accept", "cifFile", "commands", "command", "primCommands",
  "primCommand", "defDefineCommand", "defStartCommand", "defDeleteCommand",
  "defFinishCommand", "layerCommand", "polygonCommand", "boxCommand",
  "roundFlashCommand", "wireCommand", "callCommand",
  "userExtensionCommand", "UEC_cellName", "UEC_cellOverlap",
  "UEC_labelLoc", "UEC_labelSig", "commentText", "commentCommand",
  "cifPoint", "cifTrans", "cifLtrans", "cifPath", "cifBlank", "cifSep",
  "semiColon", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    34,    35,    35,    35,    35,    36,    36,    37,    37,
      37,    38,    38,    39,    39,    39,    39,    39,    39,    39,
      39,    39,    39,    39,    39,    40,    41,    41,    42,    43,
      44,    45,    46,    46,    47,    48,    49,    50,    51,    52,
      53,    53,    53,    53,    54,    55,    55,    56,    56,    57,
      58,    58,    58,    58,    59,    59,    60,    60,    61,    61,
      62,    62,    63
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     3,     1,     1,     3,     3,     1,     1,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     5,     9,     4,     4,
       4,     3,     7,     9,     4,     5,     5,     2,     2,     4,
       4,     4,     6,     6,     4,     0,     1,     3,     5,     3,
       3,     3,     3,     3,     0,     3,     1,     3,     0,     1,
       1,     1,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     5,     4,    58,    59,     0,     0,     0,     2,     1,
       0,    45,    58,    58,    58,    58,     0,    58,    58,    58,
       0,     0,     0,     0,     0,     8,    10,     0,     9,    17,
      13,    14,    15,    16,    18,    19,    20,    21,    22,    23,
      24,     0,    37,    46,     0,     3,     0,     0,     0,     0,
       0,     0,     0,    38,     0,     0,     0,     0,     0,    58,
       7,     0,     6,    47,    45,     0,    58,    56,    31,     0,
      60,    61,     0,     0,    58,    54,     0,     0,     0,     0,
       0,    62,     0,     0,     0,    28,     0,     0,     0,    34,
       0,    30,    58,    49,    39,    44,    41,    40,    58,     0,
      25,    11,    48,    26,    57,     0,    35,    36,     0,     0,
       0,    12,     0,     0,    58,    58,    58,    55,    43,    42,
      58,     0,    32,     0,     0,     0,    29,     0,     0,    50,
      51,    52,    53,    27,    33
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     5,     6,    24,    82,    25,    26,    27,    28,   100,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    44,    40,    67,   117,    92,    68,     7,    87,    60
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -42
static const yytype_int16 yypact[] =
{
     113,   -42,   -42,     8,   -42,    40,    12,   142,   -42,   -42,
      26,    17,     8,     8,     8,     8,    29,     8,     8,     8,
      28,    30,    32,   -14,    47,   -42,   -42,    47,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,    47,   -42,   -42,    27,   -42,    21,    30,    36,    13,
      37,    46,    48,   -42,    13,    45,    49,    50,    51,     8,
     -42,   182,   -42,   -42,    17,    52,     8,   -42,    13,    13,
     -42,   -42,    30,    13,     8,   -42,    57,    30,    30,    30,
      30,   -42,   153,    47,    62,   -42,    58,    30,    60,   -42,
      30,   -42,     8,   -42,   -42,   -42,    56,    59,     8,    47,
     -42,   -42,   -42,    13,   -42,    13,    13,   -23,    63,    64,
      66,   -42,    68,    30,     8,     8,     8,   -42,   -42,   -42,
       8,    13,    13,    30,    11,    30,   -42,    69,    30,   -42,
     -42,   -42,   -42,   -42,   -42
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -42,   -42,   -42,    81,   -42,   -32,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,    33,    54,   -20,   -42,   -42,     0,    -3,   -41,   -22
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -59
static const yytype_int16 yytable[] =
{
       8,    55,   114,   115,    57,    61,   116,    58,    72,    45,
      46,    47,    48,    76,    50,    51,    52,    10,    11,    62,
      12,    13,    14,    15,    16,    17,    18,    19,    88,    83,
      65,     4,    90,    11,    63,    70,    71,    66,   130,   131,
       9,    43,    20,    21,    22,    23,    42,    49,    54,    53,
      99,    59,    89,    56,    69,    73,    81,    94,    95,    96,
      97,   101,   112,    86,   113,    74,    75,   104,    77,   102,
      85,    91,    78,    79,    80,    93,   103,   111,   105,   108,
     127,   128,   109,   120,   118,   119,   121,   133,    41,   107,
     106,     0,     0,   122,     0,   110,     0,    84,    64,     0,
       0,     0,     0,   129,     0,   132,     0,     0,   134,     0,
       0,   123,   124,   125,     1,     0,     2,   126,   -58,   -58,
       0,     3,   -58,   -58,   -58,   -58,   -58,   -58,   -58,     0,
       0,     0,     0,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,   -58,   -58,   -58,   -58,    10,    11,     0,
       0,    13,    14,    15,    16,    17,    18,    19,    10,    11,
       0,     0,    98,    14,    15,    16,    17,    18,    19,     0,
       0,     0,    20,    21,    22,    23,     0,     0,     0,     0,
       0,     0,     0,    20,    21,    22,    23,    10,    11,     0,
       0,     0,    14,    15,    16,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    20,    21,    22,    23
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-42))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       3,    21,    25,    26,    18,    27,    29,    21,    49,    12,
      13,    14,    15,    54,    17,    18,    19,     5,     6,    41,
       8,     9,    10,    11,    12,    13,    14,    15,    69,    61,
       9,    23,    73,     6,     7,    22,    23,    16,    27,    28,
       0,    24,    30,    31,    32,    33,    20,    18,    18,    21,
      82,     4,    72,    21,    18,    18,    59,    77,    78,    79,
      80,    83,   103,    66,   105,    19,    18,    87,    23,     7,
      18,    74,    23,    23,    23,    18,    18,    99,    18,    23,
     121,   122,    23,    17,    21,    21,    18,    18,     7,    92,
      90,    -1,    -1,   113,    -1,    98,    -1,    64,    44,    -1,
      -1,    -1,    -1,   123,    -1,   125,    -1,    -1,   128,    -1,
      -1,   114,   115,   116,     1,    -1,     3,   120,     5,     6,
      -1,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,     5,     6,    -1,
      -1,     9,    10,    11,    12,    13,    14,    15,     5,     6,
      -1,    -1,     9,    10,    11,    12,    13,    14,    15,    -1,
      -1,    -1,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    30,    31,    32,    33,     5,     6,    -1,
      -1,    -1,    10,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     8,    23,    35,    36,    61,    61,     0,
       5,     6,     8,     9,    10,    11,    12,    13,    14,    15,
      30,    31,    32,    33,    37,    39,    40,    41,    42,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      56,    37,    20,    24,    55,    61,    61,    61,    61,    18,
      61,    61,    61,    21,    18,    57,    21,    18,    21,     4,
      63,    63,    63,     7,    56,     9,    16,    57,    60,    18,
      22,    23,    62,    18,    19,    18,    62,    23,    23,    23,
      23,    61,    38,    39,    55,    18,    61,    62,    62,    57,
      62,    61,    59,    18,    57,    57,    57,    57,     9,    39,
      43,    63,     7,    18,    57,    18,    60,    61,    23,    23,
      61,    63,    62,    62,    25,    26,    29,    58,    21,    21,
      17,    18,    57,    61,    61,    61,    61,    62,    62,    57,
      27,    28,    57,    18,    57
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 75 "cif_yacc.yy"
    {}
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 76 "cif_yacc.yy"
    {}
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 77 "cif_yacc.yy"
    {ciferror("Unexpected symbol", (yylsp[(1) - (1)]));YYABORT;}
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 78 "cif_yacc.yy"
    {YYABORT;}
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 82 "cif_yacc.yy"
    {}
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 83 "cif_yacc.yy"
    {}
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 87 "cif_yacc.yy"
    {}
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 88 "cif_yacc.yy"
    {}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 89 "cif_yacc.yy"
    {}
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 93 "cif_yacc.yy"
    {}
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 94 "cif_yacc.yy"
    {}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 98 "cif_yacc.yy"
    {}
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 99 "cif_yacc.yy"
    {}
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 100 "cif_yacc.yy"
    {}
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 101 "cif_yacc.yy"
    {}
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 102 "cif_yacc.yy"
    {}
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 103 "cif_yacc.yy"
    {}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 104 "cif_yacc.yy"
    {}
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 105 "cif_yacc.yy"
    {}
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 106 "cif_yacc.yy"
    {}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 107 "cif_yacc.yy"
    {}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 108 "cif_yacc.yy"
    {}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 109 "cif_yacc.yy"
    {}
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 113 "cif_yacc.yy"
    {}
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 117 "cif_yacc.yy"
    {
      if (checkPositive((yyvsp[(5) - (5)].integer), (yylsp[(5) - (5)])))
         CIFInFile->addStructure((yyvsp[(5) - (5)].integer));
   }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 121 "cif_yacc.yy"
    {
      bool valid = true;
      valid &= checkPositive((yyvsp[(5) - (9)].integer),(yylsp[(5) - (9)]));
      valid &= checkPositive((yyvsp[(7) - (9)].integer),(yylsp[(7) - (9)]));
      valid &= checkPositive((yyvsp[(9) - (9)].integer),(yylsp[(9) - (9)]));
      if (valid)
         CIFInFile->addStructure((yyvsp[(5) - (9)].integer), (yyvsp[(7) - (9)].integer), (yyvsp[(9) - (9)].integer));
   }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 132 "cif_yacc.yy"
    {/*check tknTword*/ciferror("defDeleteCommand - not implemented yet", (yylsp[(1) - (4)]));}
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 136 "cif_yacc.yy"
    {
      CIFInFile->doneStructure();
   }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 142 "cif_yacc.yy"
    {
      CIFInFile->secureLayer((yyvsp[(3) - (4)].identifier));
      delete (yyvsp[(3) - (4)].identifier);
   }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 149 "cif_yacc.yy"
    {
      CIFInFile->addPoly((yyvsp[(3) - (3)].path));
   }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 155 "cif_yacc.yy"
    {
      bool valid = true;
      valid &= checkPositive((yyvsp[(3) - (7)].integer),(yylsp[(3) - (7)]));
      valid &= checkPositive((yyvsp[(5) - (7)].integer),(yylsp[(5) - (7)]));
      if (valid)
         CIFInFile->addBox((yyvsp[(3) - (7)].integer), (yyvsp[(5) - (7)].integer), (yyvsp[(7) - (7)].point));
      else
      { /*@TODO clean-up the input params and flag an error!*/}
   }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 164 "cif_yacc.yy"
    {
      bool valid = true;
      valid &= checkPositive((yyvsp[(3) - (9)].integer),(yylsp[(3) - (9)]));
      valid &= checkPositive((yyvsp[(5) - (9)].integer),(yylsp[(5) - (9)]));
      if (valid)
         CIFInFile->addBox((yyvsp[(3) - (9)].integer), (yyvsp[(5) - (9)].integer), (yyvsp[(7) - (9)].point), (yyvsp[(9) - (9)].point));
      else
      { /*@TODO clean-up the input params and flag an error!*/}
   }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 176 "cif_yacc.yy"
    {/*check tknTword*/ciferror("roundFlashCommand - not implemented yet", (yylsp[(1) - (4)]));}
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 180 "cif_yacc.yy"
    {
      if (checkPositive((yyvsp[(3) - (5)].integer), (yylsp[(3) - (5)])))
         CIFInFile->addWire((yyvsp[(5) - (5)].path), (yyvsp[(3) - (5)].integer));
   }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 187 "cif_yacc.yy"
    {
      if (checkPositive((yyvsp[(3) - (5)].integer), (yylsp[(3) - (5)])))
         CIFInFile->addRef((yyvsp[(3) - (5)].integer), (yyvsp[(4) - (5)].ctmp));
   }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 194 "cif_yacc.yy"
    {
      std::ostringstream ost;
      ost << "Unsupported user command: \"" << (yyvsp[(1) - (2)].integer) << (yyvsp[(2) - (2)].identifier) << "\"";
      cifwarning(ost.str().c_str(), (yylsp[(1) - (2)]));
      delete (yyvsp[(2) - (2)].identifier);
   }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 203 "cif_yacc.yy"
    {
      CIFInFile->curCellName((yyvsp[(2) - (2)].identifier));
      delete (yyvsp[(2) - (2)].identifier);
   }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 210 "cif_yacc.yy"
    {
      CIFInFile->curCellOverlap((yyvsp[(2) - (4)].point), (yyvsp[(4) - (4)].point));
      delete (yyvsp[(2) - (4)].point);
      delete (yyvsp[(4) - (4)].point);
   }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 218 "cif_yacc.yy"
    {
      CIFInFile->addLabelLoc((yyvsp[(2) - (4)].identifier), (yyvsp[(4) - (4)].point));
      delete (yyvsp[(2) - (4)].identifier);
   }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 222 "cif_yacc.yy"
    {
      /* This version and the last one is to make the scaner's life easier.
      It's difficult to distinguish at this point between the text
      coordinate and the text itself esspecially if the text is a number */
      char i2s[256];
      sprintf(i2s, "%ld", (yyvsp[(2) - (4)].integer));
      CIFInFile->addLabelLoc(i2s, (yyvsp[(4) - (4)].point));
   }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 230 "cif_yacc.yy"
    {
      CIFInFile->addLabelLoc((yyvsp[(2) - (6)].identifier), (yyvsp[(4) - (6)].point), (yyvsp[(6) - (6)].identifier));
      delete (yyvsp[(2) - (6)].identifier);
      delete (yyvsp[(6) - (6)].identifier);
   }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 235 "cif_yacc.yy"
    {
      char i2s[256];
      sprintf(i2s, "%ld", (yyvsp[(2) - (6)].integer));
      CIFInFile->addLabelLoc(i2s, (yyvsp[(4) - (6)].point), (yyvsp[(6) - (6)].identifier));
      delete (yyvsp[(6) - (6)].identifier);
   }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 244 "cif_yacc.yy"
    {
      CIFInFile->addLabelSig((yyvsp[(2) - (4)].identifier), (yyvsp[(4) - (4)].point));
      delete (yyvsp[(2) - (4)].identifier);
   }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 251 "cif_yacc.yy"
    {}
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 252 "cif_yacc.yy"
    {(yyval.identifier) = (yyvsp[(1) - (1)].identifier);}
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 256 "cif_yacc.yy"
    { delete (yyvsp[(2) - (3)].identifier); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 257 "cif_yacc.yy"
    { delete (yyvsp[(2) - (5)].identifier); delete (yyvsp[(4) - (5)].identifier); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 261 "cif_yacc.yy"
    {
      (yyval.point) = DEBUG_NEW TP((yyvsp[(1) - (3)].integer), (yyvsp[(3) - (3)].integer));
   }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 267 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM(); (yyval.ctmp)->Translate(*(yyvsp[(3) - (3)].point));delete (yyvsp[(3) - (3)].point);
   }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 270 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM(); (yyval.ctmp)->FlipY();
   }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 273 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM(); (yyval.ctmp)->FlipX();
   }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 276 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM(); (yyval.ctmp)->Rotate(*((yyvsp[(3) - (3)].point)));delete (yyvsp[(3) - (3)].point);
   }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 282 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM();
   }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 285 "cif_yacc.yy"
    {
      (yyval.ctmp) = DEBUG_NEW CTM(*((yyvsp[(1) - (3)].ctmp)) * (*((yyvsp[(3) - (3)].ctmp))));
      delete (yyvsp[(1) - (3)].ctmp);
      delete (yyvsp[(3) - (3)].ctmp);
   }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 293 "cif_yacc.yy"
    {
      (yyval.path) = DEBUG_NEW PointVector();
      (yyval.path)->push_back(*((yyvsp[(1) - (1)].point)));
      delete ((yyvsp[(1) - (1)].point));
   }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 298 "cif_yacc.yy"
    {
      (yyvsp[(1) - (3)].path)->push_back(*((yyvsp[(3) - (3)].point)));
      delete ((yyvsp[(3) - (3)].point));
}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 305 "cif_yacc.yy"
    {}
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 306 "cif_yacc.yy"
    {}
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 310 "cif_yacc.yy"
    {}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 311 "cif_yacc.yy"
    {}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 315 "cif_yacc.yy"
    {}
    break;



/* Line 1806 of yacc.c  */
#line 2161 "cif_yacc.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 318 "cif_yacc.yy"


/*-------------------------------------------------------------------------*/
int ciferror (const char *s)
{  /* Called by yyparse on error */
      std::ostringstream ost;
      ost << "line " << ciflloc.first_line << ": col " << ciflloc.first_column
            << ": " << s;
      tell_log(console::MT_ERROR,ost.str());
      return 0;
}

void ciferror (std::string s, TpdYYLtype loc)
{
   cifnerrs++;
   std::ostringstream ost;
   ost << "line " << loc.first_line << ": col " << loc.first_column << ": ";
   if (loc.filename) {
      std::string fn = loc.filename;
      ost << "in file \"" << fn << "\" : ";
   }
   ost << s;
   tell_log(console::MT_ERROR,ost.str());
}

void cifwarning (std::string s, TpdYYLtype loc)
{
   std::ostringstream ost;
   ost << "line " << loc.first_line << ": col " << loc.first_column << ": ";
   if (loc.filename) {
      std::string fn = loc.filename;
      ost << "in file \"" << fn << "\" : ";
   }
   ost << s;
   tell_log(console::MT_WARNING,ost.str());
}

bool checkPositive(long var, TpdYYLtype loc)
{
   if (var < 0)
   {
      ciferror("Positive integer expected", loc);
      return false;
   }
   return true;
}

